diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/libstdc++-v3/libsupc++/typeinfo gcc-3.4.4-3/libstdc++-v3/libsupc++/typeinfo
--- gcc-3.4.4-3-orig/libstdc++-v3/libsupc++/typeinfo	2003-07-05 05:05:40.000000000 +0100
+++ gcc-3.4.4-3/libstdc++-v3/libsupc++/typeinfo	2005-06-03 21:03:44.000000000 +0100
@@ -44,7 +44,7 @@
   class __class_type_info;
 } // namespace __cxxabiv1
 
-#if !__GXX_WEAK__
+#if !__GXX_WEAK__ || defined (__MINGW32__) || defined (__CYGWIN__)
   // If weak symbols are not supported, typeinfo names are not merged.
   #define __GXX_MERGED_TYPEINFO_NAMES 0
 #else
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/libstdc++-v3/libsupc++/unwind-cxx.h gcc-3.4.4-3/libstdc++-v3/libsupc++/unwind-cxx.h
--- gcc-3.4.4-3-orig/libstdc++-v3/libsupc++/unwind-cxx.h	2003-07-05 05:05:42.000000000 +0100
+++ gcc-3.4.4-3/libstdc++-v3/libsupc++/unwind-cxx.h	2006-05-13 17:35:40.000000000 +0100
@@ -125,9 +125,16 @@
 extern void __terminate(std::terminate_handler) __attribute__((noreturn));
 extern void __unexpected(std::unexpected_handler) __attribute__((noreturn));
 
-// The current installed user handlers.
+ // The current installed user handlers.
+#if defined  (__MINGW32__) || defined (__CYGWIN__)
+extern "C" void** __w32_sharedptr_terminate;
+extern "C" void** __w32_sharedptr_unexpected;
+#define __terminate_handler (*(std::terminate_handler*)(__w32_sharedptr_terminate))
+#define __unexpected_handler (*(std::unexpected_handler*)(__w32_sharedptr_unexpected))
+#else
 extern std::terminate_handler __terminate_handler;
 extern std::unexpected_handler __unexpected_handler;
+#endif
 
 // These are explicitly GNU C++ specific.
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/ltcf-c.sh gcc-3.4.4-3/ltcf-c.sh
--- gcc-3.4.4-3-orig/ltcf-c.sh	2003-11-19 05:29:32.000000000 +0000
+++ gcc-3.4.4-3/ltcf-c.sh	2005-06-03 21:03:32.000000000 +0100
@@ -38,17 +38,17 @@
 lt_simple_link_test_code='main(){return(0);}'
 
 ## Linker Characteristics
-case $host_os in
-cygwin* | mingw*)
+#case $host_os in
+#cygwin* | mingw*)
   # FIXME: the MSVC++ port hasn't been tested in a loooong time
   # When not using gcc, we currently assume that we are using
   # Microsoft Visual C++.
-  if test "$with_gcc" != yes; then
-    with_gnu_ld=no
-  fi
-  ;;
-
-esac
+#  if test "$with_gcc" != yes; then
+#    with_gnu_ld=no
+#  fi
+#  ;;
+#
+#esac
 
 ld_shlibs=yes
 if test "$with_gnu_ld" = yes; then
